"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
require("./index.scss");
var React = require("react");
var recompose_1 = require("recompose");
var element_gutter_1 = require("./element-gutter");
var project_gutter_1 = require("./project-gutter");
var stage_1 = require("./stage");
var text_editor_1 = require("./text-editor");
var breadcrumbs_1 = require("./breadcrumbs");
var react_dnd_1 = require("react-dnd");
var react_dnd_html5_backend_1 = require("react-dnd-html5-backend");
var state_1 = require("front-end/state");
exports.WorkspaceBase = function (_a) {
    var state = _a.state, workspace = _a.workspace, browser = _a.browser, dispatch = _a.dispatch;
    var stage = workspace.stage;
    return React.createElement("div", { className: "workspace-component" },
        stage.showLeftGutter ? React.createElement(project_gutter_1.ProjectGutter, { workspace: workspace, browser: browser, dispatch: dispatch }) : null,
        React.createElement("div", { className: "workspace-editors" },
            stage.showTextEditor ? React.createElement(text_editor_1.TextEditor, { file: state_1.getSelectedWorkspaceFile(state, workspace), cursorPosition: workspace.textEditor.cursorPosition, dispatch: dispatch }) : null,
            React.createElement("div", { className: "workspace-stage" },
                React.createElement(stage_1.Stage, { workspace: workspace, dispatch: dispatch, browser: browser }),
                React.createElement(breadcrumbs_1.Breadcrumbs, { workspace: workspace, dispatch: dispatch, browser: browser }))),
        stage.showRightGutter ? React.createElement(element_gutter_1.ElementGutter, { browser: browser, workspace: workspace, dispatch: dispatch }) : null);
};
exports.Workspace = recompose_1.compose(recompose_1.pure, react_dnd_1.DragDropContext(react_dnd_html5_backend_1.default))(exports.WorkspaceBase);
//# sourceMappingURL=index.js.map