"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
require("./affected-nodes.scss");
var React = require("react");
var aerial_common2_1 = require("aerial-common2");
var recompose_1 = require("recompose");
var state_1 = require("front-end/state");
var AffectedElementBase = function (_a) {
    var element = _a.element, window = _a.window, zoom = _a.zoom;
    var elementBounds = window.allComputedBounds && window.allComputedBounds[element.$id];
    if (!elementBounds)
        return null;
    var _b = aerial_common2_1.shiftBounds(elementBounds, window.bounds), left = _b.left, top = _b.top, right = _b.right, bottom = _b.bottom;
    var borderWidth = 1 / zoom;
    var style = {
        boxShadow: "inset 0 0 0 " + borderWidth + "px #F5AB35",
        left: left,
        top: top,
        width: right - left,
        height: bottom - top
    };
    return React.createElement("div", { className: "affected-element", style: style });
};
var AffectedElement = recompose_1.compose(recompose_1.pure)(AffectedElementBase);
var AffectedNodesToolBase = function (_a) {
    var workspace = _a.workspace, browser = _a.browser, zoom = _a.zoom;
    var targetElementRef = workspace.selectionRefs.reverse().find(function (_a) {
        var $type = _a[0];
        return $type === state_1.SYNTHETIC_ELEMENT;
    });
    if (!targetElementRef) {
        return null;
    }
    var targetElement = state_1.getSyntheticNodeById(browser, targetElementRef[1]);
    if (!targetElement) {
        return null;
    }
    var targetWindow = state_1.getSyntheticNodeWindow(browser, targetElement.$id);
    var affectedElements = state_1.getSelectorAffectedElements(targetElement.$id, state_1.filterMatchingTargetSelectors(workspace.targetCSSSelectors, targetElement, targetWindow), browser, !!workspace.stage.fullScreen);
    return React.createElement("div", { className: "m-affected-nodes" }, affectedElements.filter(function (element) { return element.$id !== targetElement.$id; }).map(function (element) { return React.createElement(AffectedElement, { zoom: zoom, key: element.$id, window: state_1.getSyntheticNodeWindow(browser, element.$id), element: element }); }));
};
exports.AffectedNodesTool = recompose_1.compose(recompose_1.pure)(AffectedNodesToolBase);
//# sourceMappingURL=affected-nodes.js.map