"use strict";
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
require("./edit-text.scss");
var React = require("react");
var recompose_1 = require("recompose");
var aerial_common2_1 = require("aerial-common2");
var actions_1 = require("front-end/actions");
var aerial_browser_sandbox_1 = require("aerial-browser-sandbox");
var TEXT_PADDING = 10;
exports.EditTextToolBase = function (_a) {
    var workspace = _a.workspace, browser = _a.browser, dispatch = _a.dispatch, setTextarea = _a.setTextarea, zoom = _a.zoom;
    if (!workspace.stage.secondarySelection)
        return null;
    var selectedNode = workspace.selectionRefs.map(function (_a) {
        var type = _a[0], id = _a[1];
        return aerial_browser_sandbox_1.getSyntheticNodeById(browser, id);
    }).shift();
    if (!aerial_browser_sandbox_1.isSyntheticDOMNode(selectedNode))
        return null;
    var nodeWindow = aerial_browser_sandbox_1.getSyntheticNodeWindow(browser, selectedNode.$id);
    var bounds = nodeWindow.allComputedBounds[selectedNode.$id];
    var computedStyle = (nodeWindow.allComputedStyles[selectedNode.$id] || {});
    if (!bounds)
        return null;
    var _b = aerial_common2_1.getBoundsSize(bounds), width = _b.width, height = _b.height;
    var style = {
        fontSize: computedStyle.fontSize,
        color: computedStyle.color,
        position: "absolute",
        left: nodeWindow.bounds.left + bounds.left,
        top: nodeWindow.bounds.top + bounds.top,
        overflow: "visible",
        background: "white",
        minWidth: width,
        minHeight: height,
        // that may be on a white background.
        zIndex: 99999999
    };
    var textStyle = {
        fontSize: computedStyle.fontSize,
        // color: computedStyle.color,
        fontFamily: computedStyle.fontFamily,
        lineHeight: computedStyle.lineHeight,
        letterSpacing: computedStyle.letterSpacing,
        textAlign: computedStyle.textAlign,
        padding: computedStyle.padding,
        border: "none",
    };
    return React.createElement("div", { style: style },
        React.createElement("span", { ref: setTextarea, style: __assign({ resize: "none", overflow: "visible", padding: 0 }, textStyle), contentEditable: true, onChange: aerial_common2_1.wrapEventToDispatch(dispatch, actions_1.stageToolEditTextChanged.bind(_this, selectedNode.$id)), onKeyDown: aerial_common2_1.wrapEventToDispatch(dispatch, actions_1.stageToolEditTextKeyDown.bind(_this, selectedNode.$id)), onBlur: aerial_common2_1.wrapEventToDispatch(dispatch, actions_1.stageToolEditTextBlur.bind(_this, selectedNode.$id)) }, aerial_browser_sandbox_1.getSyntheticNodeTextContent(selectedNode).trim()));
};
var enhanceEditTextTool = recompose_1.compose(recompose_1.pure, recompose_1.withState("textarea", "setTextarea", null), recompose_1.lifecycle({
    componentWillUpdate: function (_a) {
        var textarea = _a.textarea;
        if (textarea && this.props.textarea !== textarea) {
            textarea.focus();
            setTimeout(function () {
                var range = textarea.ownerDocument.createRange();
                range.selectNodeContents(textarea);
                var sel = textarea.ownerDocument.defaultView.getSelection();
                sel.removeAllRanges();
                sel.addRange(range);
            }, 1);
        }
    }
}));
exports.EditTextTool = enhanceEditTextTool(exports.EditTextToolBase);
//# sourceMappingURL=edit-text.js.map