"use strict";
function __export(m) {
    for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
}
Object.defineProperty(exports, "__esModule", { value: true });
__export(require("./grid"));
require("./index.scss");
var React = require("react");
var recompose_1 = require("recompose");
var edit_text_1 = require("./edit-text");
var grid_1 = require("./grid");
var windows_1 = require("./windows");
var overlay_1 = require("./overlay");
var affected_nodes_1 = require("./affected-nodes");
var selection_1 = require("./selection");
var box_model_1 = require("./box-model");
var static_position_1 = require("./static-position");
exports.ToolsLayerBase = function (_a) {
    var workspace = _a.workspace, browser = _a.browser, dispatch = _a.dispatch, translate = _a.translate;
    var showTools = workspace.stage.showTools !== false;
    var windowElement = React.createElement(windows_1.WindowsStageTool, { workspace: workspace, browser: browser, dispatch: dispatch, translate: translate });
    if (showTools === false) {
        return React.createElement("div", { className: "m-stage-tools" }, windowElement);
    }
    return React.createElement("div", { className: "m-stage-tools" },
        React.createElement(grid_1.GridStageTool, { translate: translate }),
        React.createElement(overlay_1.NodeOverlaysTool, { zoom: translate.zoom, workspace: workspace, browser: browser, dispatch: dispatch }),
        React.createElement(box_model_1.BoxModelStageTool, { zoom: translate.zoom, workspace: workspace, browser: browser }),
        React.createElement(selection_1.SelectionStageTool, { zoom: translate.zoom, workspace: workspace, browser: browser, dispatch: dispatch }),
        windowElement,
        React.createElement(static_position_1.StaticPositionStageTool, { zoom: translate.zoom, workspace: workspace, browser: browser }),
        React.createElement(edit_text_1.EditTextTool, { zoom: translate.zoom, workspace: workspace, browser: browser, dispatch: dispatch }),
        React.createElement(affected_nodes_1.AffectedNodesTool, { zoom: translate.zoom, workspace: workspace, browser: browser }));
};
exports.ToolsLayer = recompose_1.compose(recompose_1.pure)(exports.ToolsLayerBase);
//# sourceMappingURL=index.js.map