"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
require("./label.scss");
var React = require("react");
var recompose_1 = require("recompose");
var state_1 = require("front-end/state");
var SelectionLabelBase = function (_a) {
    var workspace = _a.workspace, browser = _a.browser, zoom = _a.zoom;
    if (zoom < 0.15) {
        return null;
    }
    var _b = state_1.getWorkspaceSelectionBounds(browser, workspace), left = _b.left, top = _b.top;
    var _c = workspace.selectionRefs[workspace.selectionRefs.length - 1], type = _c[0], id = _c[1];
    var targetSelectors = workspace.targetCSSSelectors;
    if (type !== state_1.SYNTHETIC_ELEMENT) {
        return null;
    }
    var element = state_1.getSyntheticNodeById(browser, id);
    var label = state_1.getSyntheticElementLabel(element);
    var titleScale = Math.max(1 / zoom, 0.3);
    var style = {
        left: left,
        top: top,
        transform: "translate(" + 13 * titleScale + "px, -" + 15 * titleScale + "px) scale(" + titleScale + ")"
    };
    return React.createElement("div", { className: "m-selection-label", style: style }, label);
};
var enhanceSelectionLabel = recompose_1.compose(recompose_1.pure);
exports.SelectionLabel = enhanceSelectionLabel(SelectionLabelBase);
//# sourceMappingURL=label.js.map