"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
require("./index.scss");
var actions_1 = require("front-end/actions");
if (typeof window !== "undefined") {
    require("codemirror/lib/codemirror.css");
    require("codemirror/mode/javascript/javascript");
    require("codemirror/mode/xml/xml");
    require("codemirror/mode/css/css");
    require("codemirror/theme/dracula.css");
}
var React = require("react");
var CodeMirror = require("react-codemirror");
var recompose_1 = require("recompose");
var MODES = {
    "application/javascript": "javascript",
    "text/html": "xml",
    "text/css": "css",
};
exports.TextEditorBase = function (_a) {
    var options = _a.options, file = _a.file, dispatch = _a.dispatch, setCodeMirror = _a.setCodeMirror;
    return React.createElement("div", { className: "text-editor-component" },
        React.createElement(CodeMirror, { ref: setCodeMirror, options: {
                theme: "dracula",
                mode: file && MODES[file.contentType]
            }, onChange: function (value) { return dispatch(actions_1.textEditorChanged(file, value)); } }));
};
exports.TextEditor = recompose_1.compose(recompose_1.pure, recompose_1.withState("codeMirror", "setCodeMirror", null), recompose_1.lifecycle({
    componentWillUpdate: function (_a) {
        var codeMirror = _a.codeMirror, cursorPosition = _a.cursorPosition, file = _a.file;
        if (codeMirror) {
            if (cursorPosition !== this.props.cursorPosition) {
                setImmediate(function () {
                    codeMirror.focus();
                    codeMirror.codeMirror.setCursor({ line: cursorPosition.line - 1, ch: cursorPosition.column - 1 });
                });
            }
            if (file !== this["_file"] && codeMirror.codeMirror.getValue() !== String(file.content)) {
                this["_file"] = file;
                var scrollInfo = codeMirror.codeMirror.getScrollInfo();
                codeMirror.codeMirror.setValue(String(file.content));
                codeMirror.codeMirror.scrollTo(scrollInfo.left, scrollInfo.top);
            }
        }
    }
}))(exports.TextEditorBase);
//# sourceMappingURL=index.js.map